'Version vom 03.03.2010

Set WshShell = Wscript.CreateObject("WScript.Shell")
Set FSO      = CreateObject("Scripting.FileSystemObject")
Set net      = Wscript.createObject("Wscript.network")
Set db1      = CreateObject("ADODB.Connection")
Dim Aktiv, Log, Logpfad


'**************************************************************
'Einstellungen / Settings
'**************************************************************
'Logs / Debug
Log=1                            'Bei 1 werden Logfiles erstellt. Bei 0 nicht / 1 = creating logfiles 0 = no logfiles
Logpfad="C:\"         			 'Pfad fr Logfile / logfile-path

'Fr MediaPortal Powerscheduler
Aktion=0                         'Aktionen fr Powerscheduler 0=Standby, 1=Hibernation, 2=Keine Aktion / Options for PS 0 = Standby, 1 = Hibernate, 2 = no action

'Fr Mediaportal SQL Zugriff / MP SQL-access
SQLServer=  "HTPC\SQLEXPRESS"
SQLUser=    "sa"
SQLPW=      "xxx"
DWH=        "MpTvDb"

'**************************************************************
'Start (diverse Einstellungen)
'**************************************************************
Aktiv=0        'Das muss so. Sobald ein Kriterium zum wachbleiben erfllt ist, erhht sich der Wert.
               'Ist der Wert am Ende des Scripts noch immer 0, dann wird der Powerscheduler fr Standby konfiguriert.
	       'Must be zero. As soon as a criteria to keep the server running is fullfilled the value is increased
	       'PS will be configured for standby if the value of -Aktiv- is still zero at the end of the script 	
SingleStart    'Doppelausfhrung verhindern / avoid running more than one instance
Taskliste      'Es wird unter c:\taskliste.txt eine Liste aller aktiven Programme erstellt.
               'Hieraus knnen die Suchbgriffe fr die Programmprfung bernommen werden.
               'A list of all acrive processes will be created as c:\tasklist.txt. It is intended to deliver the search-arguments for testing which programs are running

'**************************************************************
'Beginn Hauptprogramm / Start main program
'**************************************************************
Do while 1=1 ' Beginn Endlosschleige / start infinity loop
logdatei "--- Start ---"
Aktiv=0

'**************************************************************
'Prfen ob Programme online / check for programs running
'**************************************************************
'z.B.
WSHCheckTask ("Notepad.exe")
'WSHCheckTask ("flatster.exe")
'WSHCheckTask ("iexplore.exe")

'**************************************************************
'Prfen ob Rechner online / check for computers running
'**************************************************************
'z.B.
'WSHonline ("Buerorechner")
WSHonline ("192.168.0.2")

'**************************************************************
'Befehl ausfhren und Ergebnis durchsuchen / submit statement and search for results
'**************************************************************
'z.B.
'cmdline "dir C:\","testdatei.txt"
cmdline "protqry.exe -n xxx.dyndns.org -e 8080","LISTENING" 

'**************************************************************
'Prfen ob sich eine Datei im Ordner befindet / searching for files
'**************************************************************
'OrdnerMitFiles ("C:\Temp")
OrdnerMitFiles ("D:\Data")


'**************************************************************
'Aktion nach X Minuten im Powerscheduler konfigurieren /configure action after x minutes in PS
'**************************************************************
if Aktiv=0 then
    'Datenbankabfrage / Database request
    on error resume next 'Bei Fehler Script fortsetzen / continue script after fault
    db1.Open("Driver={SQL Server};SERVER="&SQLServer&";Database="&DWH&";User ID="&SQLUser&";Password="&SQLPW)
    CheckFehler
    db1.execute("UPDATE Setting SET value = "&Aktion&" WHERE idSetting = 88")
    db1.close
    'Fehlerprfung wieder aktivieren
    on error goto 0
	Logdatei "Set Powerscheduler = "&Aktion
else
    'Datenbankabfrage / Database request
    on error resume next 'Bei Fehler Script fortsetzen / continue script after fault
    db1.Open("Driver={SQL Server};SERVER="&SQLServer&";Database="&DWH&";User ID="&SQLUser&";Password="&SQLPW)
    CheckFehler
    db1.execute("UPDATE Setting SET value = 2 WHERE idSetting = 88")
    db1.close
    'Fehlerprfung wieder aktivieren / reactivate fault-test
    on error goto 0
	Logdatei "Set Powerscheduler = 2 (keine Aktion)"
end if

wscript.sleep 3*60000 '3 Minuten / 1000 = 1 Sekunde
loop 'Wieder zum Schleifenanfang




'**************************************************************
Sub SingleStart 'sobald gleiches Script bereits luft,
                'wird das aktuelle Script beendet
		'as soon as the script is already running, the running script will be terminated
'**************************************************************
  Anz = 0
  Const wbemFlagReturnImmediately = &h10
  Const wbemFlagForwardOnly = &h20
  Dim objWMIService : Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
  Dim colItems      : Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
  Dim objItem
  For Each objItem In colItems
    If InStr( LCase( objItem.CommandLine), LCase( WScript.ScriptFullName ) ) > 0 Then
       Anz = Anz + 1
    End If
  Next
  if Anz>1 then
  wscript.quit
  end if

End Sub

'********************************************************************************************
Sub WSHCheckTask (textx) 'Sobald Task aktiv, wird Variable "Aktiv" und eins erhht / increase -Aktiv- for an active tasks

  Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
  wbemFlagReturnImmediately = &h10:wbemFlagForwardOnly = &h20
  Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
  For Each objItem In colItems
    if instr(lcase(objItem.CommandLine),lcase(textx))>0 then
    Aktiv=Aktiv+1
    Logdatei "Anwend aktiv:   "&textx
    end if
  Next
end Sub

'********************************************************************************************
Sub WSHonline (textx) 'Sobald Rechner aktiv, wird Variable "Aktiv" und eins erhht / increase -Aktive- for a running client
'********************************************************************************************
Set cPingResults = GetObject("winmgmts:{impersonationLevel=impersonate}//./root/cimv2"). ExecQuery("SELECT * FROM Win32_PingStatus WHERE Address = '" + textx + "'")
For Each oPingResult In cPingResults
	If oPingResult.StatusCode = 0 Then
	Aktiv=Aktiv+1
        Logdatei "IP aktiv:   "&textx
	End If
Next
end Sub

'********************************************************************************************
Sub Taskliste
'********************************************************************************************
  Set FileOut = fso.createTextFile(logpfad&"\taskliste.txt",True)
    Set objWMIService = GetObject("winmgmts:\\.\root\CIMV2")
    wbemFlagReturnImmediately = &h10:wbemFlagForwardOnly = &h20
    Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_Process", "WQL", wbemFlagReturnImmediately + wbemFlagForwardOnly)
      For Each objItem In colItems
        FileOut.WriteLine objItem.CommandLine&" "
      Next
  FileOut.Close
  Set FileOut = Nothing
End Sub

'-------------------------------------------------------------------------------
Sub LogDatei (LogTxt) '01.01.2007
'-------------------------------------------------------------------------------
if log=1 then
  on error resume next
  Set FileOut = fso.OpenTextFile( logpfad&"\PowerScheduler.log" , 8, true)
      FileOut.WriteLine Now()&"  "&LogTxt
      FileOut.Close
  Set FileOut = Nothing
  on error goto 0
end if
End Sub

'-------------------------------------------------------------------------------
sub cmdline(textx,texty)'
'-------------------------------------------------------------------------------
intReturn = WshShell.Run("cmd.exe /u /c "&textx&" >C:\tmp.txt" , 0, true)
Set FileIn = FSO.getFile("C:\tmp.txt")
set FileIn2 = FileIn.openAsTextStream(1,-1) '-1 = Unicode
set FileIn3 = FileIn.openAsTextStream(1,0) '0 = Ascii
  if instr(FileIn2.readall&FileIn3.readall,texty)>0 then
  Aktiv=Aktiv+1
  end if
fileIn2.close
fileIn3.close
fso.deletefile("c:\tmp.txt")
end sub

'**************************************************************
Sub CheckFehler
'**************************************************************
if err.number<>0 then
      logdatei "Fehler:" & Err.Description
      err.clear
end if
end sub

'**************************************************************
Sub OrdnerMitFiles (Pfadangabe) 'Prfen ob sich eine Datei im Ordner befindet / searching for an existing file in directory
'**************************************************************
if Aktiv=0 then
   Set f = fso.GetFolder(Pfadangabe)
   Set fc = f.Files
     For Each f1 in fc
     Aktiv=Aktiv+1
     Next
end if
end sub
